// AssignCommand.java
//
// For final project, cs110. 
// Based on Juno shell command.
// Ethan Bolker  Spring 2004

import java.util.*;

/**
 * The WISE command to assign a Professor to a course
 */
public class AssignCommand extends WISECommand 
{
    private final static String USAGE =
	"usage: assign course professor";

    /**
     * Assign a professor to a course.
     *
     * @param args the remainder of the command line.
     * @param wise the current WISE.
     *
     * @exception WISEException for reporting errors
     */
    public void doIt( StringTokenizer args, WISE wise )
	 throws WISEException  
    {
	try {
	    String courseName    = args.nextToken();
	    String professorName = args.nextToken();
	    Professor professor  = wise.getProfessor(professorName);
	    Course course        = wise.getCourse(courseName);
	    course.add(professor);
	}
	catch( NoSuchElementException e ) {
	    throw new WISEException( USAGE );
	}
    }
}
