// AvailableCommand.java
//
// For final project, cs110. 
// Based on Juno shell command.
// Ethan Bolker  Spring 2004

import java.util.*;

/**
 * The WISE command to check available times
 */
public class AvailableCommand extends WISECommand
{
    private final static String USAGE =
	"usage: available courses|professors time\n" +
	"       available studentName|id";

    /**
     * Check for times.
     *
     * @param args the remainder of the command line.
     * @param wise the current WISE.
     *
     * @exception WISEException for reporting errors
     */
    public void doIt( StringTokenizer args, WISE wise )
    	 throws WISEException  
    {
	Terminal t = wise.getTerminal();
	String firstArg = null;
	WISEList mainList = null;
	try {
	    firstArg = args.nextToken(); 
	    mainList = wise.get(firstArg);
	}
	catch( NoSuchElementException e ) {
	    throw new WISEException(USAGE);
	}
	catch( WISEException e) { 
	    // firstArg not a list, so try student name
	    Student student = wise.getStudent( firstArg );
	    TimeOfDay[] allTimes = TimeOfDay.getAllTimes();
	    for( int i = 0; i < allTimes.length; i++ ) {
		if (student.isAvailable( allTimes[i] )) {
		    t.println( allTimes[i] );
		}
	    }
	    return;
	}
	// now we have the list of courses or professors, 
	// so get the time of day
	TimeOfDay tod = null;
	try {
	    tod = new TimeOfDay( args.nextToken(), args.nextToken() );
	}
	catch( NoSuchElementException e ) {
	    throw new WISEException(USAGE);
	}
	Iterator i = mainList.iterator();
	while (i.hasNext()) {
	    WISEObject obj = (WISEObject)i.next();
	    if (obj.isAvailable( tod )) {
		t.println(obj.getName());
	    }
	}
    }
}
