// EnrollCommand.java
//
// For final project, cs110. 
// Based on Juno shell command.
// Ethan Bolker  Spring 2004

import java.util.*;

/**
 * The WISE command to enroll a student in a course
 * Usage:
 * <pre>
 *     enroll student[name|id] course
 * </pre>

 */
public class EnrollCommand extends WISECommand 
{
    /**
     * Enroll a student in a course.
     *
     * @param args the remainder of the command line.
     * @param wise the current WISE.
     *
     * @exception WISEException for reporting errors
     */
    public void doIt( StringTokenizer args, WISE wise )
	 throws WISEException  
    {
	try {
	    String studentName = args.nextToken();
	    String courseName  = args.nextToken();
	    Student student    = wise.getStudent(studentName);
	    Course course      = wise.getCourse(courseName);
	    student.add(course);
	}
	catch( NoSuchElementException e ) {
	    throw new WISEException( "usage: enroll studentName|ID course" );
	}
    }
}
