// FileCommand.java
//
// For final project, cs110. 
// Based on Juno shell command.
// Ethan Bolker  Spring 2004

import java.io.*;
import java.util.*;

/**
 * The WISE command to write a requested list to a file.
 */
public class FileCommand extends OutputCommand 
{
    private final static String USAGE =
	"usage: file filename students|courses|professors [name]";

    private BufferedWriter outStream = null;

    public void output( String string ) 
	throws WISEException
    {
	try {
	    outStream.write( string );
	    outStream.newLine();
	}
	catch (IOException e) {
	    throw new WISEException( e.getMessage() );
	}
    }

    public void cleanUp( )
	throws WISEException
    {
	try {
	    outStream.close();
	}
	catch (IOException e) {
	    throw new WISEException( e.getMessage() );
	}
    }

    /**
     * Write a requested list to a file.
     *
     * @param args the remainder of the command line.
     * @param wise the current WISE.
     *
     * @exception WISEException for reporting errors
     */
    public void doIt( StringTokenizer args, WISE wise )
    	 throws WISEException  
    {
	String fileName = null;
	try {
	    fileName  = args.nextToken();
	    outStream = new BufferedWriter(new FileWriter(fileName));
	}
	catch( NoSuchElementException e ) {
	    throw new WISEException(USAGE);
	}
	catch( Exception e ) {
	    throw new WISEException( e.getMessage() );
	}
	super.doIt( args, wise );
    }
}
