// OutputCommand.java
//
// For final project, cs110. 
// Based on Juno shell command.
// Ethan Bolker  Spring 2004

import java.util.*;

/**
 * Abstract command to generate WISE output.
 *
 * @see TypeCommand
 * @see FileCommand
 */
public abstract class OutputCommand extends WISECommand 
{
    /**
     * Output a requested list.
     *
     * @param args the remainder of the command line.
     * @param wise the current WISE.
     *
     * @exception WISEException for reporting errors
     */
    public void doIt( StringTokenizer args, WISE wise )
	 throws WISEException  
    {
	try {
	    String listName   = args.nextToken();
	    WISEList mainList = wise.get(listName);
	    if (! args.hasMoreTokens() ) {
		output( mainList.getPrintableList());
		return;
	    }
	    String wiseObjectName = args.nextToken();
	    WISEObject wiseObject = mainList.get(wiseObjectName);
	    WISEList subList      = wiseObject.getList();
	    output( subList.getPrintableList());
	}
	catch( WISEException e ) {
	    throw e;
	}
	finally {
	    cleanUp();
	}
    }

    public abstract void output( String string )
	throws WISEException;

    public void cleanUp( )
	throws WISEException
    {
    }
}
