// Student.java
//
// Ethan Bolker
// May, 2004 for cs110 final project

import java.util.*;

/**
 * A Student object in the WISE system.
 */
public class Student extends WISEObject
{
    // private fields for Student attributes
    private String id;

    /**
     * Construct a new Student.
     */
    public Student( StringTokenizer st )
    {
	super(st.nextToken());
	id = st.nextToken();
	setList( new Schedule(this) );
    }

    public String getId()
    { 
	return id;
    }

    public String toString()
    {
	return getName() + "\t" + id;
    }

    /**
     * Add a Course for this Student.
     */
    public void add( Course course )
	throws WISEException
    {
	if (getList().contains( course )) {
	    throw new WISEException( 
 	      getName() +  " already enrolled in course " +
	      course.getName());
	}
	if ( ! isAvailable( course.getTimeOfDay())) {
	    throw new WISEException( 
 	      getName() +  " not free " +  course.getTimeOfDay());
	}
	course.add(this); // WISEException if course full.
	getList().put( course );
    }

    private class Schedule extends CourseList
    {
	public Schedule( Student student )
	{
	    super("Schedule for Student " + student);
	}

	public String getHeader( ) 
	{
	    StringBuffer buf = new StringBuffer("*** CS110 WISE ***\n");
	    buf.append( this.getName());
	    buf.append( "\n");
	    buf.append( (new Date()).toString() );
	    buf.append( "\n\nCourses\nname  time  capacity");
	    return buf.toString();
	}
    }
}
