// StudentList.java
//
// For final project, cs110. 
// Based on example in exam2
// Ethan Bolker  Spring 2004

import java.util.*;

public class StudentList extends WISEList
{
    public StudentList( String name )
    {
	super(name);
    }

    public StudentList( String name, String studentFileName )
	throws WISEException
    {
	super( name, studentFileName );
    } 

    public WISEObject parseLine( StringTokenizer st ) 
    {
	return new Student( st );
    }

    // override get from WISEList to look for Student by ID
    public WISEObject get( String name )
	throws WISEException
    {
	try {
	    return super.get(name);
	}
	catch( WISEException e ) {
	    // not there keyed by name, try id
	}
	Iterator i = iterator();
	while( i.hasNext() ) {
	    Student student = (Student)i.next();
	    if (name.equals( student.getId())) {
		return student;
	    }
	}
	throw new WISEException( name + " not found in  " + getName());
    }

    public String getHeader( ) 
    {
	return "# *** CS110 WISE ***\n# List of students\n" + 
	       "#\n# name        id";
    }
}
