// TimeOfDay.java
//
// Ethan Bolker
// May, 2004 for cs110 final project

public class TimeOfDay
{
    private String days;
    private String hour;

    private final static TimeOfDay[] allTimes = 
    { 
	new TimeOfDay("MWF", "9", 1),
	new TimeOfDay("MWF", "10", 1),
	new TimeOfDay("MWF", "11", 1),
	new TimeOfDay("MWF", "12", 1),
	new TimeOfDay("MWF", "1", 1),
	new TimeOfDay("MWF", "2", 1),
	new TimeOfDay("MWF", "3", 1),
	new TimeOfDay("MWF", "4", 1),
	new TimeOfDay("MWF", "5", 1),
	new TimeOfDay("MWF", "6", 1),
	new TimeOfDay("MWF", "7", 1),
	new TimeOfDay("MWF", "8", 1),
	new TimeOfDay("TTh", "9", 1),
	new TimeOfDay("TTh", "10", 1),
	new TimeOfDay("TTh", "11", 1),
	new TimeOfDay("TTh", "12", 1),
	new TimeOfDay("TTh", "1", 1),
	new TimeOfDay("TTh", "2", 1),
	new TimeOfDay("TTh", "3", 1),
	new TimeOfDay("TTh", "4", 1),
	new TimeOfDay("TTh", "5", 1),
	new TimeOfDay("TTh", "6", 1),
	new TimeOfDay("TTh", "7", 1),
	new TimeOfDay("TTh", "8", 1)
    };

    // private constructor used to fill array of legal times
    private TimeOfDay( String days, String hour, int dummy )
    {
	this.days = days.trim(); 
	this.hour = hour.trim();
    }
    
    /**
     * Create a TimeOfDay instance.
     *
     * @throw WISEException if format unacceptable.
     */
    public TimeOfDay( String days, String hour )
	throws WISEException
    {
	this.days = days.trim(); // just in case there are blanks
	this.hour = hour.trim();
 	if (! this.isLegal() ) {
	    throw new WISEException
		("Illegal time of day: " + days + " " + hour);
	}
    }

    public boolean equals( Object obj )
    {
	if (! (obj instanceof TimeOfDay) ) {
	    return false;
	}
	TimeOfDay otherTime = (TimeOfDay)obj;
	return ((this.days).equalsIgnoreCase(otherTime.days) &&
		(this.hour).equals(otherTime.hour));
    }

    public String toString()
    {
	return days + " " + hour;
    }

    /**
     * Is a TimeOfDay one of the legal times?
     */
    public boolean isLegal( )
    {
	for( int i = 0; i < allTimes.length; i++ ) {
	    if (allTimes[i].equals(this)) {
		return true;
	    }
	}
	return false;
    }

    public static TimeOfDay[] getAllTimes() 
    {
	return allTimes;
    }

    public static void main( String[] args ) 
    {
	System.out.println("unit test for TimeOfDay");
	try {
	    TimeOfDay tod1 = new TimeOfDay("MWF", "  10  ");
	    TimeOfDay tod2 = new TimeOfDay("mwf", "10");
	    TimeOfDay tod3 = new TimeOfDay("TTh", "11");
	    System.out.println("Should see MWF 10: " + tod1);
	    System.out.println("Should see true:   " + 
			       (tod1.equals(tod2)));
	    System.out.println("Should see false:  " + 
			       (tod1.equals("MWF 10")));
	    System.out.println("Should see false:  " + 
			       (tod1.equals(tod3)));
	    tod3 = new TimeOfDay("MW", "10");
	}
	catch (WISEException e) {
	    System.out.println(e);
	}
    }
}
