// TypeCommand.java
//
// For final project, cs110. 
// Based on Juno shell command.
// Ethan Bolker  Spring 2004

import java.util.*;

/**
 * The WISE command to type a requested list.
 */
public class TypeCommand extends OutputCommand 
{
    private final static String USAGE =
	"usage: type students|courses|professors [name]";

    private Terminal t;

    public void output( String string ) 
    {
	t.println( string );
    }

    /**
     * Type a requested list.
     *
     * @param args the remainder of the command line.
     * @param wise the current WISE.
     *
     * @exception WISEException for reporting errors
     */
    public void doIt( StringTokenizer args, WISE wise )
    	 throws WISEException  
    {
	t = wise.getTerminal();
	super.doIt( args, wise );
    }
}
