// WISECommand.java
//
// For final project, cs110. 
// Based on Juno shell command dispatch table.
// Ethan Bolker  Spring 2004

import java.util.StringTokenizer;

/**
 * Model those features common to all WISE commands. 
 * 
 * Each concrete extension of this class provides a constructor 
 * and an implementation for method doIt.
 */

public abstract class WISECommand 
{
    /**
     * Execute the command.
     *
     * @param args the remainder of the command line.
     * @param sh   the current WISE
     *
     * @exception WISEException for reporting errors
     */
    public abstract void doIt( StringTokenizer args, WISE sh )
        throws WISEException;
}
