// WISEObject.java
//
// Ethan Bolker
// May, 2004 for cs110 final project

import java.util.*;

/**
 * An object in the WISE system (Student, Course, Professor)
 */
public abstract class WISEObject
{
    // everything has a name
    private String name;

    // Students and Professors have lists of Courses,
    // Courses have lists of Students.
    private WISEList list;

    /**
     * Construct a new WISEObject.
     */
    public WISEObject( String name )
    {
	this.name = name;
    }

    public String getName()
    {
	return name;
    }
    
    public WISEList getList() 
    {
	return list;
    }

    public void setList( WISEList list )
    {
	this.list = list;
    }

    // override this method in Course.java
    /**
     * Can a Professor or a Student use a Course at this time?
     */
    public boolean isAvailable( TimeOfDay tod )
    {
	Iterator i = list.iterator();
	while (i.hasNext()) {
	    Course course = (Course)i.next();
	    if (tod.equals(course.getTimeOfDay())) {
		return false;
	    }
	}
	return true;
    }
}






